import es, playerlib
import time
import vecmath

info = es.AddonInfo()
info.name = 'Script helper script'
info.basename = 'sh'
info.description = 'Provides some helper functions for other scripts'
info.url = 'http://addons.eventscripts.com/addons/view/sh'
info.author = 'GODJonez'
info.version = '1.1'

es.ServerVar('es_sh_v', info.version, '%d version'%info.name).makepublic()

def startTicker():
    es.addons.registerTickListener(_ticker)

def stopTicker():
    es.addons.unregisterTickListener(_ticker)

class Holder(object):
    def __init__(self, index, prop, value, secs):
        self.index = index
        self.prop = prop
        self.value = value
        self.secs = time.time() + secs
    def modify(self, now):
        pass
    def doit(self, now):
        self.modify(now)
        es.setindexprop(self.index, self.prop, str(self.value))
        if now >= self.secs:
            return False
        return True

class Functional(Holder):
    def __init__(self, index, prop, value1, value2, secs, modifier):
        now = time.time()
        self.index = index
        self.prop = prop
        if ',' in str(value1):
            self.value1 = vecmath.vector(value1)
            self.value2 = vecmath.vector(value2)
        else:
            self.value1 = float(value1)
            self.value2 = float(value2)
        self.value = self.value1
        self.secs = now + secs
        self.interval = (self.value2 - self.value1)/secs
        self.modifier = modifier
    def modify(self, now):
        self.value = self.modifier(self.value1 + self.interval*(self.secs-now))

holders = set()

def _ticker():
    if not holders:
        stopTicker()
        return
    expired = set()
    now = time.time()
    for x in holders:
        if not x.doit(now):
            expired.add(x)
    if expired:
        holders.difference_update(expired)

def holdplayerprop(userid, prop, value, secs):
    index = playerlib.getPlayer(userid).get('index') 
    return holdindexprop(index, prop, value, secs)

def linearplayerprop(userid, prop, value1, value2, secs):
    index = playerlib.getPlayer(userid).get('index')
    return linearplayerprop(index, prop, value1, value2, secs)

def functionalplayerprop(userid, prop, value1, value2, secs, modifier):
    index = playerlib.getPlayer(userid).get('index')
    return functionalindexprop(index, prop, value1, value2, secs, modifier)

def holdindexprop(index, prop, value, secs):
    holders.add(Holder(index,prop,value,secs))
    startTicker()
    return True

def linearindexprop(index, prop, value1, value2, secs):
    return functionalindexprop(index,prop,value1,value2,secs, lambda x:x)

def functionalindexprop(index, prop, value1, value2, secs, modifier):
    holders.add(Functional(index,prop,value1,value2,secs, modifier))
    startTicker()
    return True
